 /**************************************************************************
 *   Copyright (C) 2009 by Silicium628 (France)                            *
 *   http://silicium628.chez-alice.fr/                                     *
 *   http://www.silicium628.fr/                                            *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation;                                         *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY;                                             *
 *   See the GNU General Public License for more details.                  *
 ***************************************************************************/

#ifndef MAINWINDOW_H
#define MAINWINDOW_H
//
#include <QMainWindow>
#include "ui_mainwindow.h"

#include <qdir.h>
#include <math.h>
#include <stdint.h>
#include "complexe.h"
#include "vecteur3d.h"
#include "strings628.h"
#include "BSC_catalogue.h"
#include "tycho_catalogue.h"

 enum mode_dessin {totalite, partiel_BSC, partiel_NGC, partiel_TYC, impr};
 enum mode_support {ecran, imprimante};

 class QAction;
 class QActionGroup;
 class QLabel;
 class QMenu;


class MainWindow : public QMainWindow, public Ui::MainWindow
{
Q_OBJECT
public:
    MainWindow( QWidget * parent = 0, Qt::WindowFlags f = 0 );

private slots:
	void on_actionPas_de_halo_toggled(bool );
	void on_spinBox_rot_champ_valueChanged(int );
	void on_actionCatalogue_Tycho_toggled(bool );
//	void on_Bt_test_tycho_clicked();
//	void on_Bt_TYCHO_clicked();
	void on_actionAfficher_champ_CCD_toggled(bool );
	void on_Bt_chercher_clicked();
	void on_actionLettres_grecques_toggled(bool );
	void on_Bt_astuces_clicked();
	void on_actionSouligner_Etoiles_d_une_CSTL_toggled(bool );
	void on_actionEditeur_de_Constellations_toggled(bool );
	void on_actionQuitter_activated();
	void on_Bt_docNGC_clicked();
	void on_actionMode_Impression_toggled(bool );
	void on_actionImprimer_activated(int );
	void on_actionObjetsSDcardSeulement_toggled(bool );
	void on_actionCiel_Profond_toggled(bool );
	void on_spinBoxZoom_valueChanged(double );
	void on_calendrier1_clicked(QDate date);
	void on_Bt_est_clicked();
	void on_Bt_ouest_clicked();
	void on_Bt_sud_clicked();
	void on_Bt_nord_clicked();
	void on_actionPasTracerCentre_toggled(bool );
	void on_actionEtoiles_ponctuelles_toggled(bool );
	void on_actionEtoiles_blanches_toggled(bool );

 	void createActions();
 	void centrer();
 	void centrer_plus_zoom();
 	void centrer_moins_zoom();
 	void centrer_objet();
 	void a_propos_de();

	void contextMenuEvent(QContextMenuEvent *event);	
	void on_TableWidget_NGC_cellClicked(int row, int column);
	void on_actionTracer_limites_cartes_BSC5_toggled(bool );
	void on_actionTracer_Constellations_toggled(bool );
	void on_actionTracer_grille_toggled(bool );
	void on_actionAfficher_Numeros_triggered();
	void on_actionAfficher_Noms_toggled(bool );
	void on_actionTracer_Ecliptique_toggled(bool );
	void on_TableWidget_BSC_cellClicked(int row, int column);
	void designe_objet_NGC(int row);
	void on_Liste_Messier_currentRowChanged(int currentRow);
	void on_Bt_rech_Messier_clicked();
	void on_Bt_top1_clicked();
	void on_Bt_okRech2_clicked();
	void on_Bt_okRech1_clicked();
	void rechercher_TW(QString txt_i, int col_i, QTableWidget *tableWidget_i);
	void rechercher_LW(QString txt_i, QListWidget *listWidget_i);
	void on_spinBoxNGC_mag_max_valueChanged(double );
	void on_Edit_FindName_textChanged(QString );
	void on_listeNoms_currentRowChanged(int currentRow);
	void on_Bt_Go_clicked();
	void on_spinBox_magnitude_max_valueChanged(double );
	void on_spin_inc_date_valueChanged(int );
	void on_spinBox_latitude_valueChanged(int );
	void MAJ_zoom(double z);

	void on_Bt_copier_vers_cadre_clicked();
		
	void on_pushButton_Date_clicked();
	void on_timeEdit1_timeChanged(QTime date);	
	void on_tabWidget1_currentChanged(int index);
	
	void on_Edit_RA_editingFinished();
	void on_Edit_DE_editingFinished();

	void InitTableBSC(void);
	void InitTableNGC(void);
	
	int charger_texte_doc(QString nom_fichier1);	
	int charger_constellations(QString nom_fichier1);
	void on_actionRecharger_fichier_constellations_activated();		
	int Listage_objets_BSC();
	void Listage_noms_etoiles();
	int charger_fichier_SAC(); 
	
	void enregistrer_fichier_ETOILES();	// pour la SDcard
	void enregistrer_fichier_NGC();	// pour la SDcard		
	void on_actionEnregistrer_activated();
	
	void efface_objet_pointe();
	void efface_position_pointee();	
	int text2secondes (QLineEdit *Edit_i);
	
	void extraire_RA_DE_from_Tableau(int row_i, long *RA_out, long *DE_out);
	void decodage_abrev_constell(void);
	
	void calcul_aspect_etoile(float mv, float *z, float *rayon_etoile, int *rayon_halo, int *lum1);
	void calcul_anglesABC();	
	int projection(long  RAs, long  DEs, QPoint *P);
	int projection_inverse(QPoint P, long *RAs, long  *DEs);
	void trace_bande_H(int di, int pas_ri, int num_zone_min, QPainter *painter_i);
	void affiche_legende_etoiles(QPainter *painter_i);
	void trace_constellations(QPainter *painter_i, QColor couleur_ligne, QColor couleur_nom);
	void dessiner_ciel(mode_dessin mode_i);
	int trouve_etoile_at_xy(QPoint P);
	int trouve_NGC_at_xy(QPoint P);
	int trouve_TYC_at_xy(QPoint P);
	void centrer_position(long RAs, long DEs);
	void mousePressEvent(QMouseEvent *event);
	void wheelEvent (QWheelEvent * event);
	void resizeEvent(QResizeEvent *event);
	void redimmensionner_tout();
	void calcul_num_zone_BSC();

private:
	QAction *centrerAct;
	QAction *centrer_objetAct;	
	QAction *centrer_zoom_plusAct;
	QAction *centrer_zoom_moinsAct;
	QAction *aProposDeAct;
};

	int charger_noms_etoiles(QString nom_fichier1);
	int charger_figures_cstl(QString nom_fichier1);
#endif





