#include "tycho_catalogue.h"
#include <qdir.h>
#include <QTextStream>


long get_lst_Tyc2(QList<TYC2rec> *liste_etoiles_TYC, QList<RegionTYC> *Liste_regions, QString chemin_TYC, char cat)
{// complete la liste des etoiles tycho repertoriees dans la liste des regions
	QString TYC_fileName;
	QDir repertoire1;	
	QString nomCat;
	if (cat == 'A') 		{nomCat = "tyc2a628.dat";}
	else if (cat == 'B')	{nomCat = "tyc2b628.dat";}
	repertoire1.setPath(QDir::currentPath());	
	TYC_fileName = repertoire1.path() + chemin_TYC + nomCat;
	
	QFile fichier_data_etoiles(TYC_fileName);	
	if (fichier_data_etoiles.exists()) { fichier_data_etoiles.open(QIODevice::ReadOnly);	}
 	else 
	{ 	
		repertoire1.cdUp();		//si lance depuis le repertoire /run		
		TYC_fileName = repertoire1.path() + chemin_TYC + nomCat; // POUR TEST
		fichier_data_etoiles.setFileName(TYC_fileName);	
		if (fichier_data_etoiles.exists())	{ fichier_data_etoiles.open(QIODevice::ReadOnly);	}						
		else {return 1;}
	}
	QDataStream in(&fichier_data_etoiles);
	in.setByteOrder(QDataStream::LittleEndian);	
	in.setFloatingPointPrecision( QDataStream::SinglePrecision );
	
	long i_region;
	long i_region_max = Liste_regions->count();
	RegionTYC region_i;
	uint32_t num_1st_star, num_last_star, nb_etoiles;
	
	nb_etoiles = 0;

	for (i_region=1; i_region < i_region_max; i_region++) //i pointe vers les enregistrements de la 'Liste_regions'
	{	
		uint32_t num_star;
		region_i = Liste_regions->at(i_region);
		num_1st_star = region_i.n_first_etoile;
		num_last_star =region_i.n_last_etoile;
		num_star =num_1st_star;
		
		fichier_data_etoiles.reset(); // pour reprendre la lecture depuis le debut du fichier
		in.skipRawData(num_1st_star * 13); // saute les objets (blocs de 13 octets) qui precedent ceux Ã  lire
		
		while (num_star < num_last_star)
		{
			TYC2rec etoile_i;
			in >> etoile_i.ra >> etoile_i.de;
			in >> etoile_i.gscz >> etoile_i.gscn;
			in >> etoile_i.vt;	
			
			*liste_etoiles_TYC << etoile_i; 
			num_star++;
			nb_etoiles++;
		}
	
	}
	fichier_data_etoiles.close();
	return i_region;
}


int get_LSTreg_tyc2(float RA_min,float RA_max,float DE_min,float DE_max, QList<RegionTYC> *Liste_regions, QString chemin_TYC, char cat)
//complete la liste des regions Tycho qui apparaissent dans la surface affichee
{
	QString TYC_fileName;
	QDir repertoire1;	
	repertoire1.setPath(QDir::currentPath());	
	TYC_fileName = repertoire1.path() + chemin_TYC + "tyc2idx.dat";
	
	QFile fichier_index(TYC_fileName);	
	if (fichier_index.exists()) { fichier_index.open(QIODevice::ReadOnly);	}
 	else 
	{ 	
		repertoire1.cdUp();		//si lance depuis le repertoire /run		
		TYC_fileName = repertoire1.path() + chemin_TYC + "tyc2idx.dat";
		fichier_index.setFileName(TYC_fileName);	
		if (fichier_index.exists())	{ fichier_index.open(QIODevice::ReadOnly);	}
				
		else {return 1;}
	}
	QTextStream in(&fichier_index);
	QString ligne;
	float RA1, RA2, DE1, DE2;

// 1122492|598993|284.65|286.75|-29.99|-28.13	(format des ligne)
// 012345678901234567890123456789012345678901
// 000000000011111111112222222222333333333344
		
	RegionTYC region1;
	uint16_t n_region = 1; // attention pas 0 ! les regions sont numerotees Ã  partir de 1;
	uint32_t num_tyc=0;
	bool deja_lu = false;
    while ( !in.atEnd() ) 
    {
		if (! deja_lu) { ligne = in.readLine(); } else {deja_lu = false;}
		
		if (cat == 'A') 		{num_tyc = ligne.mid(8,6).toInt();} // on lit dans le catalogue tyc2a.dat
		else if (cat == 'B')	{num_tyc = ligne.mid(0,7).toInt();}	// on lit dans le catalogue tyc2b.dat
		
		RA1 = ligne.mid(15,6).toFloat(); // ANGLE en degres decimaux
		RA2 = ligne.mid(22,6).toFloat(); // ANGLE en degres decimaux
		DE1 = ligne.mid(29,6).toFloat(); // ANGLE en degres decimaux
		DE2 = ligne.mid(36,6).toFloat(); // ANGLE en degres decimaux
		
// TESTE si la region doit Ãªtre affichee (et donc rajoutee Ã  la liste)
// Voir figure "regions Ã  afficher.odg" dans le dossier tycho2 pour le principe de ce test

		if (! ((RA2 < RA_min)||(RA1 > RA_max)||(DE1 < DE_min)||(DE2 > DE_max)) ) // ordre DE1 DE2 Ã  voir...
		{
			region1.num_region = n_region;
			region1.n_first_etoile = num_tyc;
			ligne = in.readLine();				//pour connaitre le nÂ° de la derniere etoile de la region
			
			if (cat == 'A') 		{num_tyc = ligne.mid(8,6).toInt()-1;} // on lit dans le catalogue tyc2a.dat
			else if (cat == 'B')	{num_tyc = ligne.mid(0,7).toInt()-1;} // on lit dans le catalogue tyc2b.dat					
			//ce num_tyc est en fait le nÂ°-1 de la premiere etoile de la region suivante
			
			region1.n_last_etoile = num_tyc;			
			*Liste_regions << region1;
			deja_lu = true; //la ligne "suivante" vient d'Ãªtre dejÃ  lue (voir 4 lignes plus haut)
		}
		n_region++;
	}
	fichier_index.close();
	return 0;	
}


